using System;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using ELTE.TicTacToeGame.Droid.Persistence;
using ELTE.TicTacToeGame.Persistence;
using Xamarin.Forms;

[assembly: Dependency(typeof(AndroidFilePersistence))]
namespace ELTE.TicTacToeGame.Droid.Persistence
{
    /// <summary>
    /// Tic-Tac-Toe adatelrs megvalstsa Android platformra.
    /// </summary>
    public class AndroidFilePersistence : IPersistence
    {
        /// <summary>
        /// Fjl betltse.
        /// </summary>
        /// <param name="path">Elrsi tvonal.</param>
        /// <returns>A beolvasott mezrtkek.</returns>
        public async Task<Player[]> LoadAsync(String path)
        {
            // a betlts a szemlyen knyvtrbl trtnik
            String filePath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.Personal), path);

            // a fjlmveletet taszk segtsgvel vgezzk (aszinkron mdon)
            String text = await Task.Run(() => File.ReadAllText(filePath));

            return text.Split().Select(number => (Player)Int32.Parse(number)).ToArray();
        }

        /// <summary>
        /// Fjl mentse.
        /// </summary>
        /// <param name="path">Elrsi tvonal.</param>
        /// <param name="values">A mezrtkek.</param>
        public async Task SaveAsync(String path, Player[] values)
        {
            String filePath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.Personal), path);

            String text = values.Select(value => ((Int32)value).ToString()).Aggregate((value1, value2) => value1 + " " + value2);

            await Task.Run(() => File.WriteAllText(filePath, text));
        }
    }
}